/*

  catci.c : cat ci-files

  Time-stamp: <2001-06-27 09:52:53 shimo>

  shimo@ism.ac.jp 
  Hidetoshi Shimodaira

  typical usage:
  # display foo.ci
  catci foo

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "misc.h"

static const char rcsid[] = "$Id: catci.c,v 1.3 2001/08/10 06:11:44 shimo Exp $";

char *fext_ci = ".ci";

void byebye() {error("error in command line");}
void repchar(char c, int n) { int i; for(i=0;i<n;i++) putchar(c);}
  
int sw_verpose=0;
int sw_au=1;
int sw_bp=1;



/**************************************/
/* inserted to accomodate click-start */
/* inserted by Heiko Schmidt (HAS)    */
/**************************************/
int _exit_wait_optn = 0 /* FALSE */; /* global variable for switches */

/* extern "C" void getintargv(char argv0[], int *argc, char **argv[]) */
void getintargv(char argv0[], int *argc, char **argv[]) {
	int    done;
	int    count;
	int    n;
	int    l;
	char   ch;
	char  *argtmp;
	char **argstr;

	argstr = (char **)calloc(100, sizeof(char*));
	argtmp = (char  *)calloc(10000, sizeof(char));
	for(n=1; n<100; n++) {
		argstr[n] = &(argtmp[n * 100]);
	}
	argstr[0] = calloc(1+strlen(argv0), sizeof(char));
	strcpy(argstr[0], argv0);

	n=1;

	fprintf(stdout, "\nYou seem to have click-started this program,");
	fprintf(stdout, "\ndo you want to enter commandline parameters: [y]es, [n]o: ");
	fflush(stdout);

	/* read one char */
	ch = getc(stdin);
	if (ch != '\n') {
		do ;
		while (getc(stdin) != '\n');
	}
	ch = (char) tolower((int) ch);

	if (ch == 'y') {
		done=0 /* FALSE */;

		fprintf(stdout, "\nEnter single parameter [! for none]: ");
		fflush(stdout);
		count = fscanf(stdin, "%s", argstr[n]);
		do ;
		while (getc(stdin) != '\n');

		if(argstr[n][0] == '!') {
			count = 0;
		} else {
			if (strlen(argstr[n]) > 100) {
				fprintf(stdout, "\nParameter too long!!!\n");
			} else {
				n++;
			}
		}

		while(!done) {
			fprintf(stdout, "\nExecutable started:  %s", argstr[0]);
			fprintf(stdout, "\nCurrent commandline: ");
			for(l=1; l<n; l++) {
				fprintf(stdout, "%s ", argstr[l]);
			}
			fprintf(stdout, "\nQuit [q]; confirm [y]%s%s%s: ",
				(n<99 ? ", extend [e]" : ""),
				(n>1 ? ", delete last [l]" : ""),
				(n>1 ? ", delete all [a]" : ""));
			fflush(stdout);

			/* read one char */
			ch = getc(stdin);
			/* ch = getchar(); */
			if (ch != '\n') {
				do ;
				while (getc(stdin) != '\n');
				/* while (getchar() != '\n'); */
			}
			ch = (char) tolower((int) ch);
		
			switch (ch) {
				case 'y': 
					done=1 /* TRUE */;
					break;
				case 'e': 
					fprintf(stdout, "\nEnter single parameter [! for none]: ");
					fflush(stdout);
					count = fscanf(stdin, "%s", argstr[n]);
					do ;
					while (getc(stdin) != '\n');
		
					if(argstr[n][0] == '!') {
						count = 0;
					} else {
						if (strlen(argstr[n]) > 100) {
							fprintf(stdout, "\nParameter too long!!!\n");
						} else {
							n++;
						}
					}
					break;
				case 'l': 
					if (n>1) n--;
					break;
				case 'a': 
					n=1;
					break;
				case 'q': 
   					// tp_exit(0, NULL, FALSE, __FILE__, __LINE__, _exit_wait_optn);
					if(_exit_wait_optn) {
						printf("\npress [return] to finish: ");
						fflush(stdout);
						while (getchar() != '\n');
					}
					exit(0);
					break;
			}
		}
	}

	*argc = n;
	*argv = argstr;
} /* getintargv */
/*** end of inserted code (HAS) ***/




int main(int argc, char** argv)
{
  /* working variables */
  int i,j,ifile,nfile,cm,w,w2;
  FILE *fp;
  char *cbuf;
  double *alphavec=NULL;
  double **cimat=NULL, **semat=NULL, **eimat=NULL;
  double **ci0mat=NULL, **se0mat=NULL, **ei0mat=NULL;
  int nalpha;
  int *orderv; double *obsvec; /* auxiliary info */
  char **fnamev;



	/**************************************/
	/* inserted to accomodate click-start */
	/* inserted by Heiko Schmidt (HAS)    */
	/**************************************/
	{ /* local scope */
		int found=0 /* FALSE */;       /* "click" found in cmd name? */
		int n, dummyint;
		char *tmpstr;
		int     intargc; 
		char  **intargv; 
		intargc = 0; 
		intargv = NULL; 
		
		for (n = strlen(argv[0]) - 5; 
		    (n >= 0) && !found && (argv[0][n] != '/')
		             && (argv[0][n] != '\\'); n--) {

			tmpstr = &(argv[0][n]);
			dummyint = 0;
			(void)sscanf(tmpstr, "click%n", &dummyint);
			if (dummyint == 5) found = 1 /* TRUE */;
			else {
				dummyint = 0;
				(void)sscanf(tmpstr, "CLICK%n", &dummyint);
				if (dummyint == 5) found = 1 /* TRUE */;
				else {
					dummyint = 0;
					(void)sscanf(tmpstr, "Click%n", &dummyint);
					if (dummyint == 5) found = 1 /* TRUE */;
				}
			}
		}
		if(found) _exit_wait_optn = 1 /* TRUE */;

		if (_exit_wait_optn) { // get commandline parameters from keyboard
			getintargv(argv[0], &intargc, &intargv); 
			fprintf(stdout, "\n\n");
			if(intargc > 1) { // if there were option entered, use them as argc/argv
				argc = intargc; 
				argv = intargv; 
			} 
		}
	} /* local scope */
	/*** end of inserted code (HAS) ***/

  fnamev=NEW_A(argc-1,char*);
  nfile=0;

  /* args */
  for(i=1;i<argc;i++) {
    if(argv[i][0] != '-') {
      fnamev[nfile]=argv[i];
      nfile++;
    } else if(streq(argv[i],"-d")) {
      if(i+1>=argc ||
	 sscanf(argv[i+1],"%d",&debugmode) != 1)
	byebye();
      i+=1;
    } else if(streq(argv[i],"-v")) {
      sw_verpose=1;
    } else if(streq(argv[i],"--no_au")) {
      sw_au=0;
    } else if(streq(argv[i],"--no_np")) {
      sw_bp=0;
    } else byebye();
  }

  for(ifile=0;ifile<nfile;ifile++) {
    fp=openfp(fnamev[ifile],fext_ci,"r",&cbuf);
    printf("\n# reading %s",cbuf);
    cm=nalpha=0;
    orderv=fread_ivec(fp,&cm); obsvec=fread_vec(fp,&cm);
    alphavec=fread_vec(fp,&nalpha);
    cimat=fread_mat(fp,&cm,&nalpha); 
    semat=fread_mat(fp,&cm,&nalpha);
    eimat=fread_mat(fp,&cm,&nalpha);
    ci0mat=fread_mat(fp,&cm,&nalpha); 
    se0mat=fread_mat(fp,&cm,&nalpha);
    ei0mat=fread_mat(fp,&cm,&nalpha);
    fclose(fp);

    printf("\n#"); repchar(' ',17);
    w=nalpha*(sw_verpose?17:7);
    w2=w/2-2;
    if(sw_au) {
      repchar('-',w2); printf(" au "); repchar('-',w-w2-4);
    }
    printf(" |");
    if(sw_bp) {
      repchar('-',w2); printf(" np "); repchar('-',w-w2-4);
    }
    printf("\n# %4s %4s","rank","item");
    printf(" %6s","obs");
    if(sw_au) {
      for(j=0;j<nalpha;j++) {
	printf(" %6.3f",alphavec[j]);
	if(sw_verpose) printf(" %4s %4s","se","ei");
      }
    }
    printf(" |");
    if(sw_bp) {
      for(j=0;j<nalpha;j++) {
	printf(" %6.3f",alphavec[j]);
	if(sw_verpose) printf(" %4s %4s","se","ei");
      }
    }
    for(i=0;i<cm;i++) {
      printf("\n# %4d %4d",i+1,orderv[i]+1);
      printf(" %6.1f",obsvec[i]);
      if(sw_au){
	for(j=0;j<nalpha;j++) {
	  printf(" %6.1f",cimat[i][j]);
	  if(sw_verpose) printf(" %4.1f %4.1f",semat[i][j],eimat[i][j]);
	}
      }
      printf(" |");
      if(sw_bp){
	for(j=0;j<nalpha;j++) {
	  printf(" %6.1f",ci0mat[i][j]);
	  if(sw_verpose) printf(" %4.1f %4.1f",se0mat[i][j],ei0mat[i][j]);
	}
      }
    }
    printf("\n");
    free_vec(alphavec);
    free_mat(cimat); free_mat(semat); free_mat(eimat);
    free_mat(ci0mat); free_mat(se0mat); free_mat(ei0mat);
    free_ivec(orderv); free_vec(obsvec);
  }

	/**************************************/
	/* inserted to accomodate click-start */
	/* inserted by Heiko Schmidt (HAS)    */
	/**************************************/
	if(_exit_wait_optn) {
		printf("\npress [return] to finish: ");
		fflush(stdout);
		while (getchar() != '\n');
	}
	/*** end of inserted code (HAS) ***/

  return 0;
} /* main */
